#include "Appevent.ch"
#INCLUDE "DCDIALOG.CH"

#PRAGMA Library( "DCLIPX.LIB" )

PROCEDURE APPSYS()
RETURN

PROCEDURE MAIN( cButtons )
DEFAULT cButtons := '4'
TEST( Val(cButtons) )
RETURN

*************************************************************************
FUNCTION TEST( nButtons )
*************************************************************************
LOCAL GetList := {}, GetOptions,  oDlg

 LOCAL ;
 x1 := 0.6       ,;
 y1 := 0.6       ,;
 du := 15-0.2    ,;
 bb := 3-0.1     ,;
 bmpOkvir := nil ,;
 CUR := {"user32.dll",114}

 LOCAL ;
 co1 := GRA_CLR_WHITE,   co2 := GRA_CLR_DARKGREEN, ;
 co3 := GRA_CLR_BLACK,   co4 := GRA_CLR_YELLOW,    ;
 co5 := GRA_CLR_DARKRED, fo1 := "12.Arial Bold"

 LOCAL bAction, i, aButtons[nButtons], oEnd // dcpushbutton objects

 SET CHARSET TO ANSI

 bAction := {|a,b,o|AEval(aButtons,{|o|o:selected := .f.}), ;
                    o:selected := .t., ;
                    bmpOkvir:invalidateRect(), ;
                    SetAppFocus(oEnd)}

 @ 0,0.5 ;
 DCSTATIC TYPE XBPSTATIC_TYPE_GROUPBOX;
                              SIZE nButtons*15 + 1.5, 4 ;
                              OBJECT bmpOkvir ;
                              COLOR GRA_CLR_RED

FOR i := 1 TO Len(aButtons)

   @ x1,y1 ;
     DCPUSHBUTTONXP CAPTION "GROUP" + Alltrim(Str(i)) + ";F" + Alltrim(Str(i)) ;
     PARENT bmpOkvir SIZE du,bb ACCELKEY xbeK_F1 + (i-1) ;
     ACTION bAction ;
     CURSOR CUR SELECTENABLE SELECTCOLOR co1,co5 SELECTED ; // INIT SELECTED
     OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 FONT fo1 OBJECT aButtons[i] ;
     DROP {||NIL}


   y1 += 15

NEXT

//--- End
 @ 4,0 ;
   DCPUSHBUTTON CAPTION "The;End" ;
   SIZE du/2,bb ALIGNCAPTION BS_MULTILINE;
   ACTION {|a,b,o| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } CURSOR CUR OBJECT oEnd

  @ 4.2,9 DCSAY "The group is activated with mouse LbClick on the green commandbutton (Ok)"      SAYSIZE 0
  @ 5.0,9 DCSAY "The group is activated by clicking on a keyboard button F1 - Fn (??)" SAYSIZE 0
  @ 5.8,9 DCSAY "Note: Activated group must be red and the other groups are green"               SAYSIZE 0
  @ 6.6,9 DCSAY "         It must be with the keyboard F1 - Fn get RadioButtons effect"   SAYSIZE 0

 DCGETOPTIONS AUTORESIZE // WINDOWWIDTH 500 WINDOWHEIGHT 300

 DCREAD GUI TITLE "TEST :: DCPUSHBUTTONXP Tips-And-Tricks Roger Donnay" OPTIONS GetOptions FIT ;
 SETFOCUS @oEnd PARENT @oDlg MODAL ;
 EVAL {|o| Eval(bAction,nil,nil,aButtons[1]), SetAppWindow(o) }

RETURN NIL